'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded;

var _dedent = require('dedent');

var _dedent2 = _interopRequireDefault(_dedent);

var _lodash = require('lodash');

var _type = require('./type');

var _type2 = _interopRequireDefault(_type);

var _assertionDiffs = require('./assertion-diffs');

var _assertionDiffs2 = _interopRequireDefault(_assertionDiffs);

function escapeNewLines(str) {
    return _lodash.escape(str).replace(/(\r\n|\n|\r)/gm, '\\n');
}

function getAssertionMsgPrefix(err) {
    return err.message ? '"' + _lodash.escape(err.message) + '" assertion' : 'Assertion';
}

function getDiffHeader(err) {
    if (err.isArrays) return 'Arrays differ at index <code>' + err.key + '</code>:';

    if (err.isObjects) return 'Objects differ at the <code>' + _lodash.escape(err.key) + '</code> field:';

    if (err.isStrings) return 'Strings differ at index <code>' + err.key + '</code>:';

    return '';
}

function markup(err, msgMarkup) {
    var opts = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    msgMarkup = _dedent2.default('\n        <div class="message">' + _dedent2.default(msgMarkup) + '</div>\n\n        <strong>Browser:</strong> <span class="user-agent">' + err.userAgent + '</span>\n    ');

    if (err.screenshotPath) msgMarkup += '\n<div class="screenshot-info"><strong>Screenshot:</strong> <a class="screenshot-path">' + _lodash.escape(err.screenshotPath) + '</a></div>';

    if (!opts.withoutCallsite) {
        var callsiteMarkup = err.getCallsiteMarkup();

        if (callsiteMarkup) msgMarkup += '\n\n<strong>Code:</strong>\n' + callsiteMarkup;
    }

    return msgMarkup;
}

exports.default = (_TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded = {}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.okAssertion] = function (err) {
    return markup(err, '\n        ' + getAssertionMsgPrefix(err) + ' failed at step "' + _lodash.escape(err.stepName) + '":\n\n        <strong>Expected: </strong>not <code>null</code>, not <code>undefined</code>, not <code>false</code>, not <code>NaN</code> and not <code>\'\'</code>\n        <strong>Actual:   </strong><code>' + escapeNewLines(err.actual) + '</code>\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.notOkAssertion] = function (err) {
    return markup(err, '\n        ' + getAssertionMsgPrefix(err) + ' failed at step "' + _lodash.escape(err.stepName) + '":\n\n        <strong>Expected: </strong><code>null</code>, <code>undefined</code>, <code>false</code>, <code>NaN</code> or <code>\'\'</code>\n        <strong>Actual:   </strong><code>' + escapeNewLines(err.actual) + '</code>\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.eqAssertion] = function (err, maxStringLength) {
    var diff = _assertionDiffs2.default(err, maxStringLength);
    var diffMarkerStr = diff.marker ? '          ' + diff.marker : '';

    return markup(err, '\n            ' + getAssertionMsgPrefix(err) + ' failed at step "' + _lodash.escape(err.stepName) + '":\n\n            ' + getDiffHeader(err) + '\n\n            <strong>Expected: </strong><code>' + escapeNewLines(diff.expected) + '</code>\n            <strong>Actual:   </strong><code>' + escapeNewLines(diff.actual) + '</code>\n            <code>' + diffMarkerStr + '</code>\n        ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.notEqAssertion] = function (err) {
    return markup(err, '\n        ' + getAssertionMsgPrefix(err) + ' failed at step "' + _lodash.escape(err.stepName) + '":\n\n        <strong>Expected: </strong>not <code>' + escapeNewLines(err.actual) + '</code>\n        <strong>Actual:   </strong><code>' + escapeNewLines(err.actual) + '</code>\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.iframeLoadingTimeout] = function (err) {
    return markup(err, '\n        IFrame loading timed out.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.inIFrameTargetLoadingTimeout] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        IFrame target loading timed out.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.uncaughtJSError] = function (err) {
    if (err.pageDestUrl) {
        return markup(err, '\n                Uncaught JavaScript error <code>' + _lodash.escape(err.scriptErr) + '</code> on page <a href="' + err.pageDestUrl + '">' + err.pageDestUrl + '</a>\n            ');
    }

    return markup(err, '\n            Uncaught JavaScript error <code>' + _lodash.escape(err.scriptErr) + '</code> on page.\n        ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.uncaughtJSErrorInTestCodeStep] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        Uncaught JavaScript error in test code - <code>' + _lodash.escape(err.scriptErr) + '</code>.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.storeDomNodeOrJqueryObject] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        It is not allowed to share the DOM element, jQuery object or a function between test steps via "this" object.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.emptyFirstArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        A target element of the <code>' + err.action + '</code> action has not been found in the DOM tree.\n        If this element should be created after animation or a time-consuming operation is finished, use the <code>waitFor</code> action (available for use in code) to pause test execution until this element appears.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.invisibleActionElement] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        A target element <code>' + _lodash.escape(err.element) + '</code> of the <code>' + err.action + '</code> action is not visible.\n        If this element should appear when you are hovering over another element, make sure that you properly recorded the <code>hover</code> action.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.incorrectDraggingSecondArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>drag</code> action drop target is incorrect.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.incorrectPressActionArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>press</code> action parameter contains incorrect key code.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.emptyTypeActionArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        The <code>type<code> action\'s parameter text is empty.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.unexpectedDialog] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        Unexpected system <code>' + err.dialog + '</code> dialog <code>' + _lodash.escape(err.message) + '</code> appeared.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.expectedDialogDoesntAppear] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        The expected system <code>' + err.dialog + '</code> dialog did not appear.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.incorrectSelectActionArguments] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>select</code> action\'s parameters contain an incorrect value.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.incorrectWaitActionMillisecondsArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>wait</code> action\'s "milliseconds" parameter should be a positive number.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.incorrectWaitForActionEventArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>waitFor</code> action\'s first parameter should be a function, a CSS selector or an array of CSS selectors.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.incorrectWaitForActionTimeoutArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>waitFor</code> action\'s "timeout" parameter should be a positive number.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.waitForActionTimeoutExceeded] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>waitFor</code> action\'s timeout exceeded.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.incorrectGlobalWaitForActionEventArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>__waitFor</code> action\'s first parameter should be a function.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.incorrectGlobalWaitForActionTimeoutArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>__waitFor</code> action\'s "timeout" parameter should be a positive number.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.globalWaitForActionTimeoutExceeded] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>__waitFor</code> action\'s timeout exceeded.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.emptyIFrameArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        The selector within the <code>inIFrame</code> function returns an empty value.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.iframeArgumentIsNotIFrame] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        The selector within the <code>inIFrame</code> function doesn’t return an iframe element.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.multipleIFrameArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        The selector within the <code>inIFrame</code> function returns more than one iframe element.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.incorrectIFrameArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        The <code>inIFrame</code> function contains an invalid argument.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.uploadCanNotFindFileToUpload] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        Cannot find the following file(s) to upload:\n\n        ' + err.filePaths.map(function (path) {
        return '<code>' + _lodash.escape(path) + '</code>';
    }).join(',\n') + '\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.uploadElementIsNotFileInput] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>upload</code> action argument does not contain a file input element.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.uploadInvalidFilePathArgument] = function (err) {
    return markup(err, '\n        Error at step "' + _lodash.escape(err.stepName) + '":\n        <code>upload</code> action\'s "path" parameter should be a string or an array of strings.\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded[_type2.default.pageNotLoaded] = function (err) {
    return markup(err, '\n        ' + err.message + '\n    ');
}, _TYPE$okAssertion$TYPE$notOkAssertion$TYPE$eqAssertion$TYPE$notEqAssertion$TYPE$iframeLoadingTimeout$TYPE$inIFrameTargetLoadingTimeout$TYPE$uncaughtJSError$TYPE$uncaughtJSErrorInTestCodeStep$TYPE$storeDomNodeOrJqueryObject$TYPE$emptyFirstArgument$TYPE$invisibleActionElement$TYPE$incorrectDraggingSecondArgument$TYPE$incorrectPressActionArgument$TYPE$emptyTypeActionArgument$TYPE$unexpectedDialog$TYPE$expectedDialogDoesntAppear$TYPE$incorrectSelectActionArguments$TYPE$incorrectWaitActionMillisecondsArgument$TYPE$incorrectWaitForActionEventArgument$TYPE$incorrectWaitForActionTimeoutArgument$TYPE$waitForActionTimeoutExceeded$TYPE$incorrectGlobalWaitForActionEventArgument$TYPE$incorrectGlobalWaitForActionTimeoutArgument$TYPE$globalWaitForActionTimeoutExceeded$TYPE$emptyIFrameArgument$TYPE$iframeArgumentIsNotIFrame$TYPE$multipleIFrameArgument$TYPE$incorrectIFrameArgument$TYPE$uploadCanNotFindFileToUpload$TYPE$uploadElementIsNotFileInput$TYPE$uploadInvalidFilePathArgument$TYPE$pageNotLoaded);
module.exports = exports.default;